Searching values
Enable the Search plugin and call query() on each keystroke to highlight matching cells across the grid.
The Search plugin lets you scan all cells in the grid and get back a list of matches. Enable it by setting the search option to true or to a configuration object.
Once enabled, the plugin exposes the query(queryStr) method. Call it with a search string whenever the user types. By default, the search is case-insensitive and matches partial cell values.
Simplest use case
The example below:
- Enables the
Searchplugin by settingsearchtotrue - Listens for
keyupevents on a search input - Calls
query()on each keystroke and re-renders the grid to apply highlighting
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
const data = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'yellow', 'gray'],];
const container = document.querySelector('#example1');const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: true, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field');
// add a search input listenersearchField.addEventListener('keyup', (event) => { // get the `Search` plugin's instance const search = hot.getPlugin('search'); // use the `Search` plugin's `query()` method const queryResult = search.query(event.target.value);
console.log(queryResult); hot.render();});import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { Search } from 'handsontable/plugins';
// Register all Handsontable's modules.registerAllModules();
const data: (string | number)[][] = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'yellow', 'gray'],];
const container = document.querySelector('#example1')!;
const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: true, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field')!;
// add a search input listenersearchField.addEventListener('keyup', (event) => { // get the `Search` plugin's instance const search: Search = hot.getPlugin('search'); // use the `Search` plugin's `query()` method const queryResult = search.query((event.target as HTMLInputElement).value);
console.log(queryResult);
hot.render();});<div class="example-controls-container"> <div class="controls"> <input id="search_field" type="search" placeholder="Search"> </div></div><div id="example1"></div>Custom search result class
You can style search results with a custom CSS class, using the Search plugin’s searchResultClass option.
The example below highlights search results with a pink background and red text. To do this, it:
- Defines a custom CSS class called
my-class, scoped to.ht-theme-main .handsontable - Enables the
Searchplugin with a configuration object - Sets
searchResultClassto'my-class'
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
const data = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'yellow', 'gray'],];
const container = document.querySelector('#example2');const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom CSS class searchResultClass: 'my-class', }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field2');
searchField.addEventListener('keyup', (event) => { const search = hot.getPlugin('search'); const queryResult = search.query(event.target.value);
console.log(queryResult); hot.render();});import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { Search } from 'handsontable/plugins';
// Register all Handsontable's modules.registerAllModules();
const data: (string | number)[][] = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'yellow', 'gray'],];
const container = document.querySelector('#example2')!;
const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom CSS class searchResultClass: 'my-class', }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field2')!;
searchField.addEventListener('keyup', (event) => { const search: Search = hot.getPlugin('search'); const queryResult = search.query((event.target as HTMLInputElement).value);
console.log(queryResult); hot.render();});.ht-theme-main .handsontable .my-class { background: pink; color: red;}<div class="example-controls-container"> <div class="controls"> <input id="search_field2" type="search" placeholder="Search"> </div></div><div id="example2"></div>Custom query method
You can replace the built-in substring search with a custom query method, using the queryMethod option.
The example below searches only for exact matches. To do this, it:
- Defines a custom query method called
onlyExactMatchthat uses strict equality (===) - Enables the
Searchplugin with a configuration object - Sets
queryMethodtoonlyExactMatch
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
const data = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'white', 'gray'],];
// define your custom query methodfunction onlyExactMatch(queryStr, value) { return queryStr.toString() === value.toString();}
const container = document.querySelector('#example3');const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom query method queryMethod: onlyExactMatch, }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field3');
searchField.addEventListener('keyup', (event) => { const search = hot.getPlugin('search'); // use the `Search`'s `query()` method const queryResult = search.query(event.target.value);
console.log(queryResult); hot.render();});import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { Search } from 'handsontable/plugins';
// Register all Handsontable's modules.registerAllModules();
const data: (string | number)[][] = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'white', 'gray'],];
// define your custom query methodfunction onlyExactMatch(queryStr, value) { return queryStr.toString() === value.toString();}
const container = document.querySelector('#example3')!;
const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom query method queryMethod: onlyExactMatch, }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field3')!;
searchField.addEventListener('keyup', (event) => { const search: Search = hot.getPlugin('search'); // use the `Search`'s `query()` method const queryResult = search.query((event.target as HTMLInputElement).value);
console.log(queryResult);
hot.render();});<div class="example-controls-container"> <div class="controls"> <input id="search_field3" type="search" placeholder="Search"> </div></div><div id="example3"></div>Custom callback
You can add a custom callback function, using the Search plugin’s callback option.
The example below displays the number of matching search results. To do this, it:
- Defines a custom callback function called
searchResultCounterthat counts matches and calls the default callback to preserve highlighting - Enables the
Searchplugin with a configuration object - Sets
callbacktosearchResultCounter
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
let searchResultCount = 0;const data = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'white', 'gray'],];
// define your custom callback functionfunction searchResultCounter(instance, row, column, value, result) { const DEFAULT_CALLBACK = function (instance, row, col, _data, testResult) { instance.getCellMeta(row, col).isSearchResult = testResult; };
DEFAULT_CALLBACK.apply(this, [instance, row, column, value, result]);
if (result) { searchResultCount++; }}
const container = document.querySelector('#example4');const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom callback function callback: searchResultCounter, }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field4');const output = document.querySelector('#output');
searchField.addEventListener('keyup', (event) => { searchResultCount = 0;
const search = hot.getPlugin('search'); const queryResult = search.query(event.target.value);
console.log(queryResult); output.innerText = `${searchResultCount} results`; hot.render();});import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { Search } from 'handsontable/plugins';
// Register all Handsontable's modules.registerAllModules();
let searchResultCount = 0;
const data: (string | number)[][] = [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'white', 'gray'],];
// define your custom callback functionfunction searchResultCounter( instance: Handsontable.Core, row: number, column: number, value: Handsontable.CellValue, result: boolean): void { const DEFAULT_CALLBACK = function (instance, row, col, _data, testResult) { instance.getCellMeta(row, col).isSearchResult = testResult; };
DEFAULT_CALLBACK.apply(this, [instance, row, column, value, result]);
if (result) { searchResultCount++; }}
const container = document.querySelector('#example4')!;
const hot = new Handsontable(container, { data, colHeaders: true, // enable the `Search` plugin search: { // add your custom callback function callback: searchResultCounter, }, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const searchField = document.querySelector('#search_field4')!;const output = document.querySelector('#output')!;
searchField.addEventListener('keyup', (event) => { searchResultCount = 0;
const search: Search = hot.getPlugin('search'); const queryResult = search.query((event.target as HTMLInputElement).value);
console.log(queryResult); (output as HTMLElement).innerText = `${searchResultCount} results`; hot.render();});<div class="example-controls-container"> <div class="controls"> <input id="search_field4" type="search" placeholder="Search"> </div> <output class="console" id="output">0 results</output></div><div id="example4"></div>Result
After following these steps, typing in your search input highlights matching cells with the htSearchResult CSS class. The query() call returns an array of matching { row, col, data } objects that you can use to build a results counter or navigate between matches.
Related API
How query() works
Calling query(queryStr, [callback], [queryMethod]) does two things:
- Iterates over every cell in the grid and tests each one using the
queryMethod. - After each test, calls the
callbackto update cell metadata (isSearchResult).
It returns an array of result objects - one for each matching cell:
| Property | Type | Description |
|---|---|---|
row | number | Visual row index of the matching cell |
col | number | Visual column index of the matching cell |
data | string|number|null | Value of the matching cell |
After calling query(), call hot.render() to refresh visual highlighting.
Search result class
After query() runs, every cell where isSearchResult === true automatically receives the CSS class htSearchResult. You can replace this class in two ways:
- At initialization: set
search: { searchResultClass: 'my-class' } - Programmatically: call
hot.getPlugin('search').setSearchResultClass('my-class')
queryMethod signature
The queryMethod function determines whether the query string matches a cell value. It is called once per cell during every query() call.
function queryMethod(query, value, cellProperties) { // return true for a match, false otherwise}| Parameter | Type | Description |
|---|---|---|
query | string | The search string passed to query() |
value | string|number|null | The cell value (from getDataAtCell()) |
cellProperties | object | The cell’s metadata object (includes locale, type, and other cell options) |
The built-in default performs a case-insensitive, locale-aware substring match:
function defaultQueryMethod(query, value, cellProperties) { if (query === undefined || query === null || query.length === 0) { return false; } if (value === undefined || value === null) { return false; }
return value.toString().toLocaleLowerCase(cellProperties.locale) .indexOf(query.toLocaleLowerCase(cellProperties.locale)) !== -1;}You can set a custom query method in three ways:
- At initialization:
search: { queryMethod: myQueryMethod } - Programmatically:
hot.getPlugin('search').setQueryMethod(myQueryMethod) - Per
query()call:searchPlugin.query(queryStr, callback, myQueryMethod)(applies to that call only)
callback signature
The callback function is called for every cell during a query() run, whether or not the cell matches. It is responsible for updating cell metadata so the renderer knows which cells to highlight.
function callback(instance, row, col, data, testResult) { // update cell metadata based on testResult}| Parameter | Type | Description |
|---|---|---|
instance | Handsontable | The Handsontable instance |
row | number | Visual row index |
col | number | Visual column index |
data | string|number|null | The cell value |
testResult | boolean | true if the cell matches the query, false otherwise |
The built-in default sets the isSearchResult flag on each cell’s metadata:
function defaultCallback(instance, row, col, data, testResult) { instance.getCellMeta(row, col).isSearchResult = testResult;}If you override the callback to add custom logic (for example, to count results), call the default behavior manually so that cell highlighting still works.
You can set a custom callback in three ways:
- At initialization:
search: { callback: myCallback } - Programmatically:
hot.getPlugin('search').setCallback(myCallback) - Per
query()call:searchPlugin.query(queryStr, myCallback)(applies to that call only)
Per-cell queryMethod and callback
Both queryMethod and callback can be overridden for individual cells, columns, or rows using Handsontable’s cascading configuration model. Set a search object directly in a cell, columns, or rows entry:
handsontable({ data: myData, search: true, columns: [ {}, // Column 1: exact match only, everything else uses the global queryMethod { search: { queryMethod(queryStr, value) { return queryStr.toString() === value.toString(); } } } ]});You can also set it programmatically on a specific cell using setCellMeta():
hot.setCellMeta(row, col, 'search', { queryMethod(queryStr, value) { return queryStr.toString() === value.toString(); }});Per-cell settings take precedence over the plugin-level queryMethod and callback. Only queryMethod and callback support per-cell overrides - searchResultClass does not.
Plugin configuration options
Configuration options
Plugins

Skip to content

Searching values

Enable the Search plugin and call query() on each keystroke to highlight matching cells across the grid.

The Search plugin lets you scan all cells in the grid and get back a list of matches. Enable it by setting the search option to true or to a configuration object.

Once enabled, the plugin exposes the query(queryStr) method. Call it with a search string whenever the user types. By default, the search is case-insensitive and matches partial cell values.

Simplest use case

The example below:

  • Enables the Search plugin by setting search to true
  • Listens for keyup events on a search input
  • Calls query() on each keystroke and re-renders the grid to apply highlighting
Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const data = [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'yellow', 'gray'],
];
const hotSettings = ref<GridSettings>({
data,
colHeaders: true,
search: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function onSearchKeyUp(event: KeyboardEvent): void {
const target = event.currentTarget as HTMLInputElement;
const hot = hotRef.value?.hotInstance;
const search = hot?.getPlugin('search');
const queryResult = search?.query(target.value);
console.log(queryResult);
hot?.render();
}
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<div class="controls">
<input
id="search_field"
type="search"
placeholder="Search"
@keyup="onSearchKeyUp"
>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Custom search result class

You can style search results with a custom CSS class, using the Search plugin’s searchResultClass option.

The example below highlights search results with a pink background and red text. To do this, it:

  • Defines a custom CSS class called my-class, scoped to .ht-theme-main .handsontable
  • Enables the Search plugin with a configuration object
  • Sets searchResultClass to 'my-class'
CSS
.ht-theme-main .handsontable .my-class {
background: pink;
color: red;
}
Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const data = [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'yellow', 'gray'],
];
const hotSettings = ref<GridSettings>({
data,
colHeaders: true,
search: {
searchResultClass: 'my-class',
},
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function onSearchKeyUp(event: KeyboardEvent): void {
const target = event.currentTarget as HTMLInputElement;
const hot = hotRef.value?.hotInstance;
const search = hot?.getPlugin('search');
const queryResult = search?.query(target.value);
console.log(queryResult);
hot?.render();
}
</script>
<template>
<div id="example2">
<div class="example-controls-container">
<div class="controls">
<input
id="search_field2"
type="search"
placeholder="Search"
@keyup="onSearchKeyUp"
>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Custom query method

You can replace the built-in substring search with a custom query method, using the queryMethod option.

The example below searches only for exact matches. To do this, it:

  • Defines a custom query method called onlyExactMatch that uses strict equality (===)
  • Enables the Search plugin with a configuration object
  • Sets queryMethod to onlyExactMatch
Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const data = [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'white', 'gray'],
];
function onlyExactMatch(
queryStr: string | number | null | undefined,
value: string | number | null | undefined
): boolean {
return queryStr?.toString() === value?.toString();
}
const hotSettings = ref<GridSettings>({
data,
colHeaders: true,
search: {
queryMethod: onlyExactMatch,
},
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function onSearchKeyUp(event: KeyboardEvent): void {
const target = event.currentTarget as HTMLInputElement;
const hot = hotRef.value?.hotInstance;
const search = hot?.getPlugin('search');
const queryResult = search?.query(target.value);
console.log(queryResult);
hot?.render();
}
</script>
<template>
<div id="example3">
<div class="example-controls-container">
<div class="controls">
<input
id="search_field3"
type="search"
placeholder="Search"
@keyup="onSearchKeyUp"
>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Custom callback

You can add a custom callback function, using the Search plugin’s callback option.

The example below displays the number of matching search results. To do this, it:

  • Defines a custom callback function called searchResultCounter that counts matches and calls the default callback to preserve highlighting
  • Enables the Search plugin with a configuration object
  • Sets callback to searchResultCounter
Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
import type Handsontable from 'handsontable/base';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const resultCount = ref(0);
const data = [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'white', 'gray'],
];
function searchResultCounter(
instance: Handsontable,
row: number,
col: number,
_value: string | number | null,
testResult: boolean
): void {
instance.getCellMeta(row, col).isSearchResult = testResult;
if (testResult) {
resultCount.value += 1;
}
}
const hotSettings = ref<GridSettings>({
data,
colHeaders: true,
search: {
callback: searchResultCounter,
},
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function onSearchKeyUp(event: KeyboardEvent): void {
const target = event.currentTarget as HTMLInputElement;
const hot = hotRef.value?.hotInstance;
resultCount.value = 0;
const search = hot?.getPlugin('search');
const queryResult = search?.query(target.value);
console.log(queryResult);
hot?.render();
}
</script>
<template>
<div id="example4">
<div class="example-controls-container">
<div class="controls">
<input
id="search_field4"
type="search"
placeholder="Search"
@keyup="onSearchKeyUp"
>
</div>
<output class="console" id="output">
{{ resultCount }} results
</output>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Result

After following these steps, typing in your search input highlights matching cells with the htSearchResult CSS class. The query() call returns an array of matching { row, col, data } objects that you can use to build a results counter or navigate between matches.

How query() works

Calling query(queryStr, [callback], [queryMethod]) does two things:

  1. Iterates over every cell in the grid and tests each one using the queryMethod.
  2. After each test, calls the callback to update cell metadata (isSearchResult).

It returns an array of result objects - one for each matching cell:

PropertyTypeDescription
rownumberVisual row index of the matching cell
colnumberVisual column index of the matching cell
datastring|number|nullValue of the matching cell

After calling query(), call hot.render() to refresh visual highlighting.

Search result class

After query() runs, every cell where isSearchResult === true automatically receives the CSS class htSearchResult. You can replace this class in two ways:

  • At initialization: set search: { searchResultClass: 'my-class' }
  • Programmatically: call hot.getPlugin('search').setSearchResultClass('my-class')

queryMethod signature

The queryMethod function determines whether the query string matches a cell value. It is called once per cell during every query() call.

function queryMethod(query, value, cellProperties) {
// return true for a match, false otherwise
}
ParameterTypeDescription
querystringThe search string passed to query()
valuestring|number|nullThe cell value (from getDataAtCell())
cellPropertiesobjectThe cell’s metadata object (includes locale, type, and other cell options)

The built-in default performs a case-insensitive, locale-aware substring match:

function defaultQueryMethod(query, value, cellProperties) {
if (query === undefined || query === null || query.length === 0) {
return false;
}
if (value === undefined || value === null) {
return false;
}
return value.toString().toLocaleLowerCase(cellProperties.locale)
.indexOf(query.toLocaleLowerCase(cellProperties.locale)) !== -1;
}

You can set a custom query method in three ways:

  • At initialization: search: { queryMethod: myQueryMethod }
  • Programmatically: hot.getPlugin('search').setQueryMethod(myQueryMethod)
  • Per query() call: searchPlugin.query(queryStr, callback, myQueryMethod) (applies to that call only)

callback signature

The callback function is called for every cell during a query() run, whether or not the cell matches. It is responsible for updating cell metadata so the renderer knows which cells to highlight.

function callback(instance, row, col, data, testResult) {
// update cell metadata based on testResult
}
ParameterTypeDescription
instanceHandsontableThe Handsontable instance
rownumberVisual row index
colnumberVisual column index
datastring|number|nullThe cell value
testResultbooleantrue if the cell matches the query, false otherwise

The built-in default sets the isSearchResult flag on each cell’s metadata:

function defaultCallback(instance, row, col, data, testResult) {
instance.getCellMeta(row, col).isSearchResult = testResult;
}

If you override the callback to add custom logic (for example, to count results), call the default behavior manually so that cell highlighting still works.

You can set a custom callback in three ways:

  • At initialization: search: { callback: myCallback }
  • Programmatically: hot.getPlugin('search').setCallback(myCallback)
  • Per query() call: searchPlugin.query(queryStr, myCallback) (applies to that call only)

Per-cell queryMethod and callback

Both queryMethod and callback can be overridden for individual cells, columns, or rows using Handsontable’s cascading configuration model. Set a search object directly in a cell, columns, or rows entry:

handsontable({
data: myData,
search: true,
columns: [
{},
// Column 1: exact match only, everything else uses the global queryMethod
{
search: {
queryMethod(queryStr, value) {
return queryStr.toString() === value.toString();
}
}
}
]
});

You can also set it programmatically on a specific cell using setCellMeta():

hot.setCellMeta(row, col, 'search', {
queryMethod(queryStr, value) {
return queryStr.toString() === value.toString();
}
});

Per-cell settings take precedence over the plugin-level queryMethod and callback. Only queryMethod and callback support per-cell overrides - searchResultClass does not.

Plugin configuration options

Configuration options

Plugins

Angular Data GridSearching values

Search data across Handsontable, using the built-in API methods of the Search plugin, and implementing your own search UI.

Overview

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance access page.

The Search plugin provides an easy API to search data across Handsontable.

You should first enable the plugin by setting the search option to true. When enabled, the Search plugin exposes a new method query(queryStr), where queryStr is a string to find within the table. By default, the search is case insensitive.

query(queryStr, [callback], [queryMethod]) method does 2 things. First of all, it returns an array of search results. Every element is an objects containing 3 properties:

  • row – index of the row where the value has been found
  • col – index of the column where the value has been found
  • data – the value that has been found

The second thing the query() method does is set the isSearchResult property for each cell. If a cell is in search results, then its isSearchResult is set to true, otherwise the property is set to false.

All you have to do now, is use the query() method inside search input listener and you're done.

Search result class

By default, the Search plugin adds htSearchResult class to every cell which isSearchResult property is true. You can change this class using searchResultClass configuration option.

To change the result class, you use the var searchPlugin = hot.getPlugin('search'); searchPlugin.setSearchResultClass(className); method.

Custom queryMethod

The queryMethod() function is responsible for determining whether a queryStr matches the value stored in a cell. It takes 2 arguments: queryStr and cellData. The first is a string passed to query() method. The second is a value returned by getDataAtCell(). The queryMethod() function should return true if there is a match.

The default queryMethod function is dead simple:

const DEFAULT_QUERY_METHOD = function(query, value) {
  if (isUndefined(query) || query === null || !query.toLowerCase || query.length === 0) {
    return false;
  }
  if (isUndefined(value) || value === null) {
    return false;
  }

  return value.toString().toLowerCase().indexOf(query.toLowerCase()) !== -1;
};

If you want to change the queryMethod, use the queryMethod option. You can also pass the queryMethod as the third argument of query() method. To change the queryMethod, use var searchPlugin = hot.getPlugin('search'); searchPlugin.setQueryMethod(myNewQueryMethod);.

Custom result callback

After calling queryMethod the Search plugin calls callback(instance, rowIndex, colIndex, cellData, testResult) for every cell.

Just as the queryMethod, you can override this callback, using var searchPlugin = hot.getPlugin('search'); searchPlugin.setCallback(myNewCallbackFunction);, or passing your callback as the second argument of query() method.

The default callback is responsible for setting the isSearchResult property.

const DEFAULT_CALLBACK = function(instance, row, col, data, testResult) {
  instance.getCellMeta(row, col).isSearchResult = testResult;
};

Simplest use case

The example below:

  • Enables the Search plugin (by setting the search configuration option to true)
  • Adds a search input listener
  • Inside the search input listener, gets the Search plugin's instance
  • Uses the Search plugin's query() method

/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example1-searching-values',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <input
          id="search_field"
          type="search"
          placeholder="Search"
          (keyup)="searchFieldKeyup($event)"
        />
      </div>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
})
export class Example1SearchingValuesComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data: Array<Array<string | number>> = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: true,
    search: true,
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true
  };

  searchFieldKeyup(event: KeyboardEvent): void {
    const hot = this.hotTable?.hotInstance;
    // get the `Search` plugin's instance
    const search = hot?.getPlugin('search');
    // use the `Search` plugin's `query()` method
    const queryResult = search?.query((event.target as any).value);

    console.log(queryResult);

    hot?.render();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1SearchingValuesComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1SearchingValuesComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1SearchingValuesComponent ]
})

export class AppModule { }

Custom search result class

You can style your search results with a custom CSS class, using the Search plugin's searchResultClass option.

The example below highlights its search results in bold red. To do this, it:

  • Defines a custom CSS class called my-custom-search-result-class
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's searchResultClass option to 'my-custom-search-result-class'

/* file: app.component.ts */
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example2-searching-values',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <input
          id="search_field2"
          type="search"
          placeholder="Search"
          (keyup)="searchFieldKeyup($event)"
        />
      </div>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
  styles: `.my-custom-search-result-class{
      color: #ff0000;
      font-weight: 900;
    }`,
  encapsulation: ViewEncapsulation.None,
})
export class Example2SearchingValuesComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data: Array<Array<string | number>> = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: true,
    search: {
      searchResultClass: 'my-custom-search-result-class',
    },
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true
  };

  searchFieldKeyup(event: KeyboardEvent): void {
    const hot = this.hotTable?.hotInstance;
    // get the `Search` plugin's instance
    const search = hot?.getPlugin('search');
    // use the `Search` plugin's `query()` method
    const queryResult = search?.query((event.target as any).value);

    console.log(queryResult);

    hot?.render();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example2SearchingValuesComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example2SearchingValuesComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example2SearchingValuesComponent ]
})

export class AppModule { }

Custom query method

You can add a custom query method, using the Search plugin's queryMethod.

The example below searches only for exact search query matches. To do this, it:

  • Defines a custom query method called onlyExactMatch
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's queryMethod option to onlyExactMatch

/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example3-searching-values',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <input
          id="search_field3"
          type="search"
          placeholder="Search"
          (keyup)="searchFieldKeyup($event)"
        />
      </div>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
})
export class Example3SearchingValuesComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data: Array<Array<string | number>> = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: true,
    search: {
      // add your custom query method
      queryMethod: this.onlyExactMatch,
    },
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true
  };

  searchFieldKeyup(event: KeyboardEvent): void {
    const hot = this.hotTable?.hotInstance;
    // get the `Search` plugin's instance
    const search = hot?.getPlugin('search');
    // use the `Search` plugin's `query()` method
    const queryResult = search?.query((event.target as any).value);

    console.log(queryResult);

    hot?.render();
  }

  //  define your custom query method
  onlyExactMatch(
    queryStr: { toString: () => any },
    value: { toString: () => any }
  ): boolean {
    return queryStr.toString() === value.toString();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example3SearchingValuesComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example3SearchingValuesComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example3SearchingValuesComponent ]
})

export class AppModule { }

Custom callback

You can add a custom callback function, using the Search plugin's callback option.

The example below displays the number of matching search results. To do this, it:

  • Defines a custom callback function called searchResultCounter
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's callback option to searchResultCounter

/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example4-searching-values',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <input
          id="search_field3"
          type="search"
          placeholder="Search"
          (keyup)="searchFieldKeyup($event)"
        />
      </div>
      <output class="console" id="output"> {{ resultCount }} results </output>
    </div>

    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
})
export class Example4SearchingValuesComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data: Array<Array<string | number>> = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: true,
    search: {
      // add your custom callback function
      callback: (
        _instance: Handsontable,
        _row: number,
        _col: number,
        _value: any,
        result: any
      ) => this.searchResultCounter(_instance, _row, _col, _value, result),
    },
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true
  };

  resultCount = 0;

  searchFieldKeyup(event: KeyboardEvent): void {
    this.setResultCounter(0);

    const search = this.hotTable?.hotInstance?.getPlugin('search');
    const queryResult = search?.query((event.target as any).value);

    console.log(queryResult);

    this.hotTable?.hotInstance?.render();
  }

  //  define your custom callback function
  searchResultCounter(
    _instance: Handsontable,
    _row: number,
    _col: number,
    _value: any,
    result: any
  ): void {
    _instance.getCellMeta(_row, _col).isSearchResult = result;
    if (result) {
      this.setResultCounter(this.resultCount + 1);
    }
  }

  private setResultCounter(count: number): void {
    this.resultCount = count;
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example4SearchingValuesComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example4SearchingValuesComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example4SearchingValuesComponent ]
})

export class AppModule { }

React Data GridSearching values

Search data across Handsontable, using the built-in API methods of the Search plugin, and implementing your own search UI.

Overview

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance methods page.

The Search plugin provides an easy API to search data across Handsontable.

You should first enable the plugin by setting the search option to true. When enabled, the Search plugin exposes a new method query(queryStr), where queryStr is a string to find within the table. By default, the search is case insensitive.

query(queryStr, [callback], [queryMethod]) method does 2 things. First of all, it returns an array of search results. Every element is an objects containing 3 properties:

  • row – index of the row where the value has been found
  • col – index of the column where the value has been found
  • data – the value that has been found

The second thing the query() method does is set the isSearchResult property for each cell. If a cell is in search results, then its isSearchResult is set to true, otherwise the property is set to false.

All you have to do now, is use the query() method inside search input listener and you're done.

Search result class

By default, the Search plugin adds htSearchResult class to every cell which isSearchResult property is true. You can change this class using searchResultClass configuration option.

To change the result class, you use the var searchPlugin = hot.getPlugin('search'); searchPlugin.setSearchResultClass(className); method.

Custom queryMethod

The queryMethod() function is responsible for determining whether a queryStr matches the value stored in a cell. It takes 2 arguments: queryStr and cellData. The first is a string passed to query() method. The second is a value returned by getDataAtCell(). The queryMethod() function should return true if there is a match.

The default queryMethod function is dead simple:

const DEFAULT_QUERY_METHOD = function(query, value) {
  if (isUndefined(query) || query === null || !query.toLowerCase || query.length === 0) {
    return false;
  }
  if (isUndefined(value) || value === null) {
    return false;
  }

  return value.toString().toLowerCase().indexOf(query.toLowerCase()) !== -1;
};

If you want to change the queryMethod, use the queryMethod option. You can also pass the queryMethod as the third argument of query() method. To change the queryMethod, use var searchPlugin = hot.getPlugin('search'); searchPlugin.setQueryMethod(myNewQueryMethod);.

Custom result callback

After calling queryMethod the Search plugin calls callback(instance, rowIndex, colIndex, cellData, testResult) for every cell.

Just as the queryMethod, you can override this callback, using var searchPlugin = hot.getPlugin('search'); searchPlugin.setCallback(myNewCallbackFunction);, or passing your callback as the second argument of query() method.

The default callback is responsible for setting the isSearchResult property.

const DEFAULT_CALLBACK = function(instance, row, col, data, testResult) {
  instance.getCellMeta(row, col).isSearchResult = testResult;
};

Simplest use case

The example below:

  • Enables the Search plugin (by setting the search configuration option to true)
  • Adds a search input listener
  • Inside the search input listener, gets the Search plugin's instance
  • Uses the Search plugin's query() method

import { useRef, useCallback } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const data = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  const searchFieldKeyupCallback = useCallback(
    (event) => {
      const hot = hotRef.current?.hotInstance;
      // get the `Search` plugin's instance
      const search = hot?.getPlugin('search');
      // use the `Search` plugin's `query()` method
      const queryResult = search?.query(event.currentTarget.value);

      console.log(queryResult);
      hot?.render();
    },
    [hotRef.current]
  );

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <input
            id="search_field"
            type="search"
            placeholder="Search"
            onKeyUp={(event) => searchFieldKeyupCallback(event)}
          />
        </div>
      </div>
      <HotTable
        ref={hotRef}
        data={data}
        colHeaders={true}
        search={true}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Custom search result class

You can style your search results with a custom CSS class, using the Search plugin's searchResultClass option.

The example below highlights its search results in bold red. To do this, it:

  • Defines a custom CSS class called my-custom-search-result-class
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's searchResultClass option to 'my-custom-search-result-class'

import { useRef, useCallback } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const data = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'yellow', 'gray'],
  ];

  const searchFieldKeyupCallback = useCallback(
    (event) => {
      const hot = hotRef.current?.hotInstance;
      const search = hot?.getPlugin('search');
      const queryResult = search?.query(event.currentTarget.value);

      console.log(queryResult);
      hot?.render();
    },
    [hotRef.current]
  );

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <input
            id="search_field2"
            type="search"
            placeholder="Search"
            onKeyUp={(...args) => searchFieldKeyupCallback(...args)}
          />
        </div>
      </div>
      <HotTable
        ref={hotRef}
        data={data}
        colHeaders={true}
        // enable the `Search` plugin
        search={{
          // add your custom CSS class
          searchResultClass: 'my-custom-search-result-class',
        }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Custom query method

You can add a custom query method, using the Search plugin's queryMethod.

The example below searches only for exact search query matches. To do this, it:

  • Defines a custom query method called onlyExactMatch
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's queryMethod option to onlyExactMatch

import { useRef, useCallback } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const data = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'white', 'gray'],
  ];

  const searchFieldKeyupCallback = useCallback(
    (event) => {
      const hot = hotRef.current?.hotInstance;
      const search = hot?.getPlugin('search');
      // use the `Search`'s `query()` method
      const queryResult = search?.query(event.currentTarget.value);

      console.log(queryResult);
      hot?.render();
    },
    [hotRef.current]
  );

  //  define your custom query method
  function onlyExactMatch(queryStr, value) {
    return queryStr.toString() === value.toString();
  }

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <input
            id="search_field3"
            type="search"
            placeholder="Search"
            onKeyUp={(...args) => searchFieldKeyupCallback(...args)}
          />
        </div>
      </div>
      <HotTable
        ref={hotRef}
        data={data}
        colHeaders={true}
        // enable the `Search` plugin
        search={{
          // add your custom query method
          queryMethod: onlyExactMatch,
        }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Custom callback

You can add a custom callback function, using the Search plugin's callback option.

The example below displays the number of matching search results. To do this, it:

  • Defines a custom callback function called searchResultCounter
  • Enables the Search plugin (by setting the search configuration option to an object)
  • Sets the Search plugin's callback option to searchResultCounter

0 results
import { useRef, useState } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hot4Ref = useRef(null);
  const [resultCount, setResultCounter] = useState(0);
  const data = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'white', 'gray'],
  ];

  //  define your custom callback function
  function searchResultCounter(_instance, _row, _col, _value, result) {
    const DEFAULT_CALLBACK = function (instance, row, col, _data, testResult) {
      instance.getCellMeta(row, col).isSearchResult = testResult;
    };

    DEFAULT_CALLBACK.apply(this, arguments);

    if (result) {
      setResultCounter((count) => count + 1);
    }
  }

  const handleKeyUp = (event) => {
    setResultCounter(0);

    const search = hot4Ref.current?.hotInstance?.getPlugin('search');
    const queryResult = search?.query(event.currentTarget.value);

    console.log(queryResult);
    hot4Ref.current?.hotInstance?.render();
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <input id="search_field4" type="search" placeholder="Search" onKeyUp={handleKeyUp} />
        </div>
        <output className="console" id="output">
          {resultCount} results
        </output>
      </div>
      <HotTable
        ref={hot4Ref}
        data={data}
        colHeaders={true}
        // enable the `Search` plugin
        search={{
          // add your custom callback function
          callback: searchResultCounter,
        }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;